#include<iostream>
#include<list>
#include<algorithm>
#include<string>
using namespace std;
long long a[1000000],N,C,Q,Li,Ri,br1=0,i=0,j,sumal=0,sumad=0,mini;
string s;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>N>>C>>Q;
    cin>>s;
    for(int i=0;i<s.length();i++){
		 a[i]=s.at(i)-48;
    }
    for(int i=0;i<s.length();i++){
    	if(a[i]==1)br1++;
	}
    for(int i=0;i<Q;i++){
    		cin>>Li>>Ri;
    		if(Li==Ri){
				if(a[Li]==0){
					a[Li]=1;
					br1++;
				}	
				else {
					a[Li]=0;
					br1--;
				}
			}
			else{
		
    		for(int i=Li;i<=Ri;i++){
    			if(a[i]==0){
    				a[i]=1;
    				br1++;
				}
				else{
					a[i]=0;
					br1--;
				}
			}
				}
			if(C==N){
				cout<<br1;
			}
			if(C==1){
				if(N-br1>br1)cout<<N-br1;
				else cout<<br1;
			}
			else cout<<br1<<endl;
		
    		
	}
	
    return 0;
}